
/*##################################################################*/
Boolean DoAnyActionProxy ( UInt32 dwCode, TPrefs* pPrefs, TCommonVars *vars )
/*##################################################################*/
{
  Boolean Result = false;

  if ( 0 != dwCode )
  {
    vars->db = DmOpenDatabaseByTypeCreator( HACKTYPE, HACKID, dmModeReadOnly );
    
    if ( NULL != vars->db )
    {
      vars->CodeHandle = DmGet1Resource( 'code', SHARED_CODE ) ;

      if ( NULL != vars->CodeHandle )
      {
        vars->CodePointer = MemHandleLock( vars->CodeHandle );

        if ( NULL != vars->CodePointer )
        {
          Result = vars->CodePointer( dwCode, pPrefs );

          MemHandleUnlock( vars->CodeHandle );
        }

        DmReleaseResource( vars->CodeHandle );
      }

      DmCloseDatabase( vars->db );
    }
  }

  return Result;
}
/*##################################################################*/
