/*## ELaunch.h #####################################################*/

//#define TRACKME

#define	HACKID		'Elau' 
#define	HACKTYPE	'HACK'

#define	TYPE_APP	sysFileTApplication
#define	TYPE_DA		'DAcc'
#define	TYPE_PANL	sysFileTPanel

#define	DACREATORFLAG	((UInt32)0x80000000L)
#define	PANLCREATORFLAG	((UInt32)0x00800000L)

#define	ALLCREATORFLAGS ( DACREATORFLAG | PANLCREATORFLAG )

#define	APPPREFVER	5
#define	APPPREFID	0

#define	SHARED_CODE	0x0BB8

#define	FTR_VARS	1

#define	TONE_LOW	440
#define	TONE_HIGH	4400
#define	TONE_DURATION	40

#define	EVENT_STROKE	( (UInt16)firstUserEvent + 1969 )
#define	EVENT_KEY	( (UInt16)firstUserEvent + 1972 )  

enum { aAPPS, aGR_UL, aGR_UR, aCALC, 
       aMENU, aGR_LL, aGR_LR, aFIND, 
       aDISPLEFT, aDISPMIDDLE, aDISPRIGHT };

#define	FROMCOUNT	( aFIND + 1 )
#define	TOCOUNT		( aDISPRIGHT + 1 )

#define	MAXSTROKES	( FROMCOUNT * TOCOUNT )

enum { tSTYLUS, tKEYS, tMORE, tSUMMARY, tCOUNT };

enum { pDATEBOOK ,pADDRESS ,pTODO ,pMEMOPAD , pPOWER, pCRADLE , pCONTRAST, pJOGUP, pJOGDOWN, pJOGPUSH, pAUX, pCOUNT };

#define	KEYPRIMBASE	pDATEBOOK
#define	KEYPRIMCOUNT	pCOUNT

enum { kNONE, kPOWER, kPAGEUP, kPAGEDOWN, kDATEBOOK, kADDRESS, kTODO, kMEMOPAD, kCOUNT };

#define	KEYSECBASE	kNONE
#define	KEYSECCOUNT	kCOUNT

enum { sPRESS, sHOLD, sHOLDLONG, sKEYSTYLECOUNT };

#define KeyIndex(Prim,Sec,Style) ( ( (Prim) * KEYSECCOUNT + (Sec) ) * sKEYSTYLECOUNT + (Style) )

#define	MAXKEYS	  ( KEYPRIMCOUNT * KEYSECCOUNT * sKEYSTYLECOUNT ) 

enum { oBACKLIGHT, oTURNOFF, oTURNOFFLOCK, oKEYBOARD, oGRAFFITI, oBEAM, oHOTSYNC, oCONTRAST, oBRIGHTNESS, oFIND, oPAGEUP, oPAGEDOWN, oAUTOOFF, oMENU, oESCAPE, oCOMMAND,
       oCUT, oCOPY, oPASTE, oUNDO, oSELECTALL, oINVERT,
       oTOGGLESOUND, oSOUNDON, oSOUNDOFF,
       oTOGGLEBEAMRECEIVE, oBEAMRECEIVEON, oBEAMRECEIVEOFF,
       oTOGGLERECORDS, oSHOWRECORDS, oHIDERECORDS, oMASKRECORDS, oLASTAPP, oRESET, oBACKLIGHT_INVERT,
       oMUTEON, oMUTEOFF, oTOGGLEMUTE, oVOLUMEDLG,
       oAUTOCFON, oAUTOCFOFF, oTOGGLEAUTOCF,
       /*oHOTSYNCLOCAL, */oHOTSYNCREMOTE,
       oHOME, oEND, oLINE_HOME, oLINE_END,
       oGRAFFITION, oGRAFFITIOFF, oTOGGLEGRAFFITI,
       oCOUNT };

#define	SOUNDTYPES	3

register void *reg_a7 asm("%sp");
#define __getA7() (long)reg_a7
#define __setA7(a7) reg_a7= (void *)(a7)

#define DASTACKSIZE 3000

enum { cClickOnApp, cClickOnOther, cClickOnHold, cClickOnGraffiti, 
       cToggleIndication, cKeepAlarm, cIgnoreLauncher, cLaunchLast, cCOUNT };

typedef struct {
	UInt32	      	aStrokes[MAXSTROKES]; // from 0.09
	UInt32		aKeys[MAXKEYS];
	UInt16		SoundLevels[SOUNDTYPES]; 
	int		iTab;
	int	      	iStrokeFrom;
	int	      	iStrokeTo;
	int		iKeyPrim;
	int		iKeySec;
	int		iKeyStyle;
	Boolean		CheckBoxes[cCOUNT];
	UInt16		LnchCardNo0;
	LocalID		LnchDbID0;
	UInt16		LnchCardNo1;
	LocalID		LnchDbID1;
	} TPrefs;

typedef struct
{
  SysDBListItemType*	dbInfoArray;
  UInt16		dbCount;
  Char**		listItemPtrs;
} TDBlist;

typedef struct
{
  FormPtr	      	frm;
  TDBlist	      	dbList;
  UInt32*		pdwStrokeKey;
  ListPtr	      	pListApp;
  ListPtr	      	pListFrom;
  ListPtr	      	pListTo;
  ListPtr	      	pListKeyPrim;
  ListPtr	      	pListKeySec;
  ListPtr	      	pListKeyStyle;
  FieldPtr	        pSummary;
  TPrefs	      	Prefs;
} TGlobals;

/*##################################################################*/

typedef struct
{
  Boolean		Result;
  DmOpenRef		db;
  MemHandle		CodeHandle;
  Boolean		(*CodePointer)( UInt32, TPrefs* );
} TCommonVars;

/*##################################################################*/

Boolean DoAnyActionProxy ( UInt32 dwCode, TPrefs* pPrefs, TCommonVars *vars );

/*##################################################################*/
